/* this is client program for hup_handle.c */

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <errno.h>
#include <stdlib.h>
#include <unistd.h>
#include <stdio.h>
#ifdef linux
#include <error.h>
#define SEND_FLAGS MSG_NOSIGNAL
#else
#include <stdarg.h>
#include <string.h>

#define SEND_FLAGS 0

static void
error(int e_code, int err, const char * fmt, ...)
{
    va_list ap;
    va_start(ap, fmt);
    vfprintf(stderr, fmt, ap);
    if(err)
	fprintf(stderr, ": %s (%d)", strerror(err), err);
    fputs("\n", stderr);
    fflush(stderr);
    if(e_code) exit(e_code);
}
#endif


int
main(void)
{
    int s;
    struct sockaddr_in myadr;
    ssize_t chk;
    char buf[40] = {0};

    myadr.sin_family = AF_INET;
    myadr.sin_port = htons(6080);
    inet_aton("127.0.0.1", &myadr.sin_addr);

    s = socket(PF_INET, SOCK_STREAM, 0);
    if(s < 0) error(EXIT_FAILURE, errno, "No socket");
    if(connect(s, (struct sockaddr *)&myadr, sizeof(myadr)) != 0) 
	error(EXIT_FAILURE, errno, "Can't connect");
    chk = send(s, buf, sizeof(buf), SEND_FLAGS);
    if(chk != sizeof(buf)) error(EXIT_FAILURE, errno, "Can't send");
    printf("Sent %d bytes\n", (int)chk);
    sleep(1);
    return 0;
}
