#ifndef XALLOC_H
#define XALLOC_H
#include <errno.h>
#include <error.h>
#include <stdlib.h>


#define new_object(type) \
    ({ type* _p = calloc(1, sizeof(type));\
     if(_p == NULL)\
     {\
	 error(0, errno, "Can't allocate " #type );\
	 abort();\
     }\
     _p;})

#define new_zero_space(sz) \
    ({ size_t _s = (sz);\
     void * _p = calloc(1, _s);\
     if(_p == NULL)\
     {\
          error(0, errno, "Failed to allocate %zu bytes", _s);\
          abort();\
     }\
     _p;})

#define new_space(sz) \
    ({ size_t _s = (sz);\
     void * _p = malloc(_s);\
     if(_p == NULL)\
     {\
          error(0, errno, "Failed to allocate %zu bytes", _s);\
          abort();\
     }\
     _p;})

#define more_space(p, sz) \
    ({ size_t _s = (sz);\
     void * _p = realloc((p), _s);\
     if(_p == NULL)\
     {\
          error(0, errno, "Failed to reallocate %zu bytes", _s);\
          abort();\
     }\
     _p;})

#endif
